//==============================
//		O[o萔
//==============================
float4 Color = float4(1, 1, 1, 1);	//2D`掞ɏUF
float2 TexelSize;					//UVWnł1sNZ̃TCYeNZTCY
//̓eNX`
texture InputTex;
sampler InputSmp = sampler_state {
	texture = <InputTex>;
	MipFilter = LINEAR;	
	MinFilter = LINEAR;	
	MagFilter = LINEAR;	
	AddressU = Clamp;	
	AddressV = Clamp;	
};


//2D`PS
float4 NormalPS(float2 UV:TEXCOORD0) :COLOR0{
	UV += TexelSize *0.5f;
	return tex2D(InputSmp,UV) * Color;
}

technique NormalTech {
	pass P0 {
		PixelShader = compile ps_3_0 NormalPS();
		ZEnable = false;
		ZWriteEnable = false;
	}
};

float4 XBlurPS(float2 UV:TEXCOORD0) :COLOR0{
	UV += TexelSize *0.5f;
	//ڂ
	float3 color = 0;
	for (int i = -5; i <= 5; i++) {
		color += tex2D(InputSmp, UV + float2(TexelSize.x*i, 0)).rgb;
	}
	color /= 11;
	return float4(color.rgb, 1);
}

technique XBlurTech {
	pass P0 {
		PixelShader = compile ps_3_0 XBlurPS();
		ZEnable = false;
		ZWriteEnable = false;
	}
};

float4 YBlurPS(float2 UV:TEXCOORD0) :COLOR0{
	UV += TexelSize *0.5f;
	//ڂ
	float3 color = 0;
	for (int i = -5; i <= 5; i++) {
		color += tex2D(InputSmp, UV + float2(0, TexelSize.y*i)).rgb;
	}
	color /= 11;
	return float4(color.rgb, 1);
}

technique YBlurTech {
	pass P0 {
		PixelShader = compile ps_3_0 YBlurPS();
		ZEnable = false;
		ZWriteEnable = false;
	}
};